/* 
 * AMD Standard Hot Plug Controller Driver
 *
 * Copyright (C) 2002-2004 Advanced Micro Devices
 *
 * YOUR USE OF THIS CODE IS SUBJECT TO THE TERMS
 * AND CONDITIONS OF THE GNU GENERAL PUBLIC
 * LICENSE FOUND IN THE "GPL.TXT" FILE THAT IS
 * INCLUDED WITH THIS FILE AND POSTED AT
 * http://www.gnu.org/licenses/gpl.html
 *
 * Send feedback to <david.keck@amd.com>
 *
*/  
    
#include "amdshpc.h"
    
#define PCI_ID_OFFSET		0x00
#define PCI_CMD_STATUS_OFFSET	0x04
#define PCI_CLASS_INFO_OFFSET	0x08
#define PCI_HEADER_INFO_OFFSET	0x0C
#define PCI_BASE_ADDR_OFFSET	0x10
#define PCI_BUS_INFO_OFFSET	0x18
#define PCI_CAP_POINTER_OFFSET	0x34
    
#define PCI_BUS_CLASS		0x06
#define PCIX_CAPABILITY_ID	0x07
    
// Bit offsets
#define BUSMASTER_MASK				0x00000004	// [2]
#define BUSMASTER_OFFSET			2	// [2]
#define CAPABILITIESLIST_MASK			0x00100000	// [20]
#define CAPABILITIESLIST_OFFSET			20	// [20]
#define HEADERTYPE_MASK				0x003F0000	// [22..16]
#define HEADERTYPE_OFFSET			16	// [22..16]
#define MULITFUNCTION_MASK			0x00800000	// [23]
#define MULITFUNCTION_OFFSET			23	// [23]
#define SECONDARYBUS_MASK			0x0000FF00	// [15..8]
#define SECONDARYBUS_OFFSET			8	// [15..8]
#define SUBORDINATEBUS_MASK			0x00FF0000	// [23..16]
#define SUBORDINATEBUS_OFFSET			16	// [23..16]
#define CAPABILITYID_MASK			0x000000FF	// [7..0]
#define CAPABILITYID_OFFSET			0	// [7..0]
#define PTRTONEXTCAP_MASK			0x0000FF00	// [15..8]
#define PTRTONEXTCAP_OFFSET			8	// [15..8]
#define FEATURESPECIFIC_MASK			0xFFFF0000	// [31..16]
#define FEATURESPECIFIC_OFFSET			16	// [31..16]
#define MAX_MEM_READ_BYTE_CNT_MASK		0x0000000C	// [3..2]
#define MAX_MEM_READ_BYTE_CNT_OFFSET		2	// [3..2]
#define MAX_OUTSTANDING_SPLIT_TRANS_MASK	0x00000070	// [6..4]
#define MAX_OUTSTANDING_SPLIT_TRANS_OFFSET	4	// [6..4]
#define DESIGNED_MAX_MEM_READ_BYTE_CNT_MASK	0x00600000	// [22..21]
#define DESIGNED_MAX_MEM_READ_BYTE_CNT_OFFSET		21	// [22..21]
#define DESIGNED_MAX_OUTSTANDING_SPLIT_TRANS_MASK	0x03800000	// [25..23]
#define DESIGNED_MAX_OUTSTANDING_SPLIT_TRANS_OFFSET	23	// [25..23]
    
