#ifndef _ASM_KPROBES_H
#define _ASM_KPROBES_H
/*
 *  Kernel Probes (KProbes)
 *  include/asm-ppc64/kprobes.h
 */
#include <linux/types.h>
#include <linux/ptrace.h>

struct pt_regs;

typedef unsigned int kprobe_opcode_t;
#define BREAKPOINT_INSTRUCTION	0x7fe00008	/* trap */
#define MAX_INSN_SIZE 1

#define IS_TW(instr)            (((instr) & 0xfc0007fe) == 0x7c000008)
#define IS_TD(instr)            (((instr) & 0xfc0007fe) == 0x7c000088)
#define IS_TDI(instr)           (((instr) & 0xfc000000) == 0x08000000)
#define IS_TWI(instr)           (((instr) & 0xfc000000) == 0x0c000000)

#ifdef CONFIG_KPROBES
extern int kprobe_handler(struct pt_regs *regs);
extern int post_kprobe_handler(struct pt_regs *regs);
extern int kprobe_fault_handler(struct pt_regs *regs, int trapnr);
#else				/* !CONFIG_KPROBES */
static inline int kprobe_handler(struct pt_regs *regs)
{
	return 0;
}
static inline int post_kprobe_handler(struct pt_regs *regs)
{
	return 0;
}
static inline int kprobe_fault_handler(struct pt_regs *regs, int trapnr)
{
	return 0;
}
#endif
#endif				/* _ASM_KPROBES_H */
